package de.sh_edraft

import de.sh_edraft.config.Config
import de.sh_edraft.data.DataService
import de.sh_edraft.events.OnJoinListener
import de.sh_edraft.events.OnLeftListener
import org.bukkit.plugin.java.JavaPlugin

open class OntimeHandlerPlugin() : JavaPlugin() {

    private lateinit var config: Config

    private lateinit var dataService: DataService

    override fun onEnable() {
        this.config = Config(logger)
        this.config.read("plugins/kd_ontime/config.properties", false)
        this.config.read("plugins/kd_ontime/config.${this.config.environment}.properties", true)
        this.config.read("plugins/kd_ontime/config.${this.config.hostName}.properties", true)

        this.dataService = DataService(logger, this.config)

        server.pluginManager.registerEvents(OnJoinListener(logger, this.dataService), this)
        server.pluginManager.registerEvents(OnLeftListener(logger, this.dataService), this)

        logger.info("OntimeHandlerPlugin enabled :D")
    }

    override fun onDisable() {
        logger.info("OntimeHandlerPlugin disabled :(")
    }
}